Index: pplinux/linuxnew/net/ipv4/netfilter/ipt_FASTNAT.c
diff -u /dev/null pplinux/linuxnew/net/ipv4/netfilter/ipt_FASTNAT.c:1.2
--- /dev/null	Tue May 24 10:37:59 2005
+++ pplinux/linuxnew/net/ipv4/netfilter/ipt_FASTNAT.c	Wed Apr  6 11:53:13 2005
@@ -0,0 +1,138 @@
+#include <linux/module.h>
+#include <linux/skbuff.h>
+#include <linux/ip.h>
+#include <linux/udp.h>
+#include <linux/tcp.h>
+#include <net/ip.h>
+#include <net/checksum.h>
+#include <linux/netfilter_ipv4/ip_tables.h>
+#include <linux/netfilter_ipv4/ipt_FASTNAT.h>
+#include <linux/netdevice.h>
+#include <linux/route.h>
+struct in_device;
+#include <net/route.h>
+
+#if 0
+#define DEBUGP printk
+#else
+#define DEBUGP(format, args...)
+#endif
+
+/* (this is stolen from ip_nat_core.c)
+ * We do checksum mangling, so if they were wrong before they're still
+ * wrong.  Also works for incomplete packets (eg. ICMP dest
+ * unreachables.) */
+static u_int16_t
+cheat_check(u_int32_t oldvalinv, u_int32_t newval, u_int16_t oldcheck)
+{
+        u_int32_t diffs[] = { oldvalinv, newval };
+        return csum_fold(csum_partial((char *)diffs, sizeof(diffs),
+                                      oldcheck^0xFFFF));
+}
+
+
+static unsigned int ipt_fastnat_target(struct sk_buff **pskb,
+				       unsigned int hooknum,
+				       const struct net_device *in,
+				       const struct net_device *out,
+				       const void *targinfo,
+				       void *userinfo)
+{
+	const struct ipt_fastnat_info *fi = targinfo;
+	struct iphdr *iph = (*pskb)->nh.iph;
+	struct udphdr *udphdr;
+	struct tcphdr *tcphdr;
+
+	/* Rewrite IP header */
+	(*pskb)->nfcache |= NFC_ALTERED;
+	switch (iph->protocol) {
+	  case IPPROTO_UDP:
+	      udphdr = (struct udphdr *)((u_int32_t *)iph + iph->ihl);
+	      if (fi->type & IPT_FASTNAT_SRC_ADDR) {
+		  udphdr->check = cheat_check(~iph->saddr, fi->saddr.s_addr,
+					      udphdr->check);
+	      }
+	      if (fi->type & IPT_FASTNAT_SRC_PORT) {
+		  udphdr->check = cheat_check(~udphdr->source, fi->sport,
+					      udphdr->check);
+		  udphdr->source = fi->sport;
+	      }
+	      if (fi->type & IPT_FASTNAT_DST_ADDR) {
+		  udphdr->check = cheat_check(~iph->daddr, fi->daddr.s_addr,
+					      udphdr->check);
+	      }
+	      if (fi->type & IPT_FASTNAT_DST_PORT) {
+		  udphdr->check = cheat_check(~udphdr->dest, fi->dport,
+					      udphdr->check);
+		  udphdr->dest = fi->dport;
+	      }
+	      break;
+	  case IPPROTO_TCP:
+	      tcphdr = (struct tcphdr *)((u_int32_t *)iph + iph->ihl);
+	      if (fi->type & IPT_FASTNAT_SRC_ADDR) {
+		  tcphdr->check = cheat_check(~iph->saddr, fi->saddr.s_addr,
+					      tcphdr->check);
+	      }
+	      if (fi->type & IPT_FASTNAT_SRC_PORT) {
+		  tcphdr->check = cheat_check(~tcphdr->source, fi->sport,
+					      tcphdr->check);
+		  tcphdr->source = fi->sport;
+	      }
+	      if (fi->type & IPT_FASTNAT_DST_ADDR) {
+		  tcphdr->check = cheat_check(~iph->daddr, fi->daddr.s_addr,
+					      tcphdr->check);
+	      }
+	      if (fi->type & IPT_FASTNAT_DST_PORT) {
+		  tcphdr->check = cheat_check(~tcphdr->dest, fi->dport,
+					      tcphdr->check);
+		  tcphdr->dest = fi->dport;
+	      }
+	}
+
+	if (fi->type & IPT_FASTNAT_SRC_ADDR) {
+	    iph->check = cheat_check(~iph->saddr, fi->saddr.s_addr,iph->check);
+	    DEBUGP("FASTNAT: src to %u.%u.%u.%u\n", NIPQUAD(fi->saddr.s_addr));
+	    iph->saddr = fi->saddr.s_addr;
+	}
+	if (fi->type & IPT_FASTNAT_DST_ADDR) {
+	    iph->check = cheat_check(~iph->daddr, fi->daddr.s_addr,iph->check);
+	    DEBUGP("FASTNAT: dst to %u.%u.%u.%u\n", NIPQUAD(fi->daddr.s_addr));
+	    iph->daddr = fi->daddr.s_addr;
+	}
+
+	return IPT_CONTINUE;
+}
+
+static int ipt_fastnat_checkentry(const char *tablename,
+				  const struct ipt_entry *e,
+				  void *targinfo,
+				  unsigned int targinfosize,
+				  unsigned int hook_mask)
+{
+	if (hook_mask & ~((1 << NF_IP_LOCAL_IN)
+			  | (1 << NF_IP_PRE_ROUTING)
+			  | (1 << NF_IP_LOCAL_OUT)
+			  | (1 << NF_IP_POST_ROUTING))) {
+		DEBUGP("FASTNAT: bad hook\n");
+		return 0;
+	}
+
+	return 1;
+}
+
+static struct ipt_target ipt_fastnat_reg
+= { { NULL, NULL }, "FASTNAT", ipt_fastnat_target, ipt_fastnat_checkentry,
+    NULL, THIS_MODULE };
+
+static int __init init(void)
+{
+	return ipt_register_target(&ipt_fastnat_reg);
+}
+
+static void __exit fini(void)
+{
+	ipt_unregister_target(&ipt_fastnat_reg);
+}
+
+module_init(init);
+module_exit(fini);
Index: pplinux/linuxnew/net/ipv4/netfilter/ipt_MARK.c
diff -u pplinux/linuxnew/net/ipv4/netfilter/ipt_MARK.c:1.1.323.1 pplinux/linuxnew/net/ipv4/netfilter/ipt_MARK.c:1.2
--- pplinux/linuxnew/net/ipv4/netfilter/ipt_MARK.c:1.1.323.1	Thu Feb  3 10:00:59 2005
+++ pplinux/linuxnew/net/ipv4/netfilter/ipt_MARK.c	Wed Apr  6 11:53:13 2005
@@ -17,8 +17,9 @@
 {
 	const struct ipt_mark_target_info *markinfo = targinfo;
 
-	if((*pskb)->nfmark != markinfo->mark) {
-		(*pskb)->nfmark = markinfo->mark;
+	if(((*pskb)->nfmark & markinfo->mask) != (markinfo->mark & markinfo->mask)) {
+		(*pskb)->nfmark &= ~markinfo->mask;
+		(*pskb)->nfmark |= markinfo->mark & markinfo->mask;
 		(*pskb)->nfcache |= NFC_ALTERED;
 	}
 	return IPT_CONTINUE;
Index: pplinux/linuxnew/net/ipv4/netfilter/iptable_fastnat.c
diff -u /dev/null pplinux/linuxnew/net/ipv4/netfilter/iptable_fastnat.c:1.1
--- /dev/null	Tue May 24 10:37:59 2005
+++ pplinux/linuxnew/net/ipv4/netfilter/iptable_fastnat.c	Thu Feb  3 11:35:39 2005
@@ -0,0 +1,184 @@
+#include <linux/module.h>
+#include <linux/netfilter_ipv4/ip_tables.h>
+
+#define FASTNAT_VALID_HOOKS ((1 << NF_IP_LOCAL_IN) | (1 << NF_IP_PRE_ROUTING) |(1 << NF_IP_LOCAL_OUT) | (1 << NF_IP_POST_ROUTING))
+
+/* Standard entry. */
+struct ipt_standard
+{
+	struct ipt_entry entry;
+	struct ipt_standard_target target;
+};
+
+struct ipt_error_target
+{
+	struct ipt_entry_target target;
+	char errorname[IPT_FUNCTION_MAXNAMELEN];
+};
+
+struct ipt_error
+{
+	struct ipt_entry entry;
+	struct ipt_error_target target;
+};
+
+static struct
+{
+	struct ipt_replace repl;
+	struct ipt_standard entries[4];
+	struct ipt_error term;
+} initial_table __initdata
+= { { "fastnat", FASTNAT_VALID_HOOKS, 5,
+      sizeof(struct ipt_standard) * 4 + sizeof(struct ipt_error),
+      { [NF_IP_LOCAL_IN] 0,
+	[NF_IP_PRE_ROUTING] sizeof(struct ipt_standard),
+	[NF_IP_LOCAL_OUT] sizeof(struct ipt_standard) * 2,
+	[NF_IP_POST_ROUTING] sizeof(struct ipt_standard) * 3 },
+      { [NF_IP_LOCAL_IN] 0,
+	[NF_IP_PRE_ROUTING] sizeof(struct ipt_standard),
+	[NF_IP_LOCAL_OUT] sizeof(struct ipt_standard) * 2,
+	[NF_IP_POST_ROUTING] sizeof(struct ipt_standard) * 3 },
+      0, NULL, { } },
+    {
+	    /* LOCAL_IN */
+	    { { { { 0 }, { 0 }, { 0 }, { 0 }, "", "", { 0 }, { 0 }, 0, 0, 0 },
+		0,
+		sizeof(struct ipt_entry),
+		sizeof(struct ipt_standard),
+		0, { 0, 0 }, { } },
+	      { { { { IPT_ALIGN(sizeof(struct ipt_standard_target)), "" } }, { } },
+		-NF_ACCEPT - 1 } },
+	    /* PRE_ROUTING */
+	    { { { { 0 }, { 0 }, { 0 }, { 0 }, "", "", { 0 }, { 0 }, 0, 0, 0 },
+		0,
+		sizeof(struct ipt_entry),
+		sizeof(struct ipt_standard),
+		0, { 0, 0 }, { } },
+	      { { { { IPT_ALIGN(sizeof(struct ipt_standard_target)), "" } }, { } },
+		-NF_ACCEPT - 1 } },
+	    /* LOCAL_OUT */
+	    { { { { 0 }, { 0 }, { 0 }, { 0 }, "", "", { 0 }, { 0 }, 0, 0, 0 },
+		0,
+		sizeof(struct ipt_entry),
+		sizeof(struct ipt_standard),
+		0, { 0, 0 }, { } },
+	      { { { { IPT_ALIGN(sizeof(struct ipt_standard_target)), "" } }, { } },
+		-NF_ACCEPT - 1 } },
+	    /* POST_ROUTING */
+	    { { { { 0 }, { 0 }, { 0 }, { 0 }, "", "", { 0 }, { 0 }, 0, 0, 0 },
+		0,
+		sizeof(struct ipt_entry),
+		sizeof(struct ipt_standard),
+		0, { 0, 0 }, { } },
+	      { { { { IPT_ALIGN(sizeof(struct ipt_standard_target)), "" } }, { } },
+		-NF_ACCEPT - 1 } },
+    },
+    /* ERROR */
+    { { { { 0 }, { 0 }, { 0 }, { 0 }, "", "", { 0 }, { 0 }, 0, 0, 0 },
+	0,
+	sizeof(struct ipt_entry),
+	sizeof(struct ipt_error),
+	0, { 0, 0 }, { } },
+      { { { { IPT_ALIGN(sizeof(struct ipt_error_target)), IPT_ERROR_TARGET } },
+	  { } },
+	"ERROR"
+      }
+    }
+};
+
+static struct ipt_table fastnat_table
+= { { NULL, NULL }, "fastnat", &initial_table.repl,
+    FASTNAT_VALID_HOOKS, RW_LOCK_UNLOCKED, NULL };
+
+/* The work comes in here from netfilter.c. */
+static unsigned int
+ipt_hook(unsigned int hook,
+	 struct sk_buff **pskb,
+	 const struct net_device *in,
+	 const struct net_device *out,
+	 int (*okfn)(struct sk_buff *))
+{
+	return ipt_do_table(pskb, hook, in, out, &fastnat_table, NULL);
+}
+
+static unsigned int
+ipt_local_out_hook(unsigned int hook,
+		   struct sk_buff **pskb,
+		   const struct net_device *in,
+		   const struct net_device *out,
+		   int (*okfn)(struct sk_buff *))
+{
+	/* root is playing with raw sockets. */
+	if ((*pskb)->len < sizeof(struct iphdr)
+	    || (*pskb)->nh.iph->ihl * 4 < sizeof(struct iphdr)) {
+		if (net_ratelimit())
+			printk("ipt_hook: happy cracking.\n");
+		return NF_ACCEPT;
+	}
+
+	return ipt_do_table(pskb, hook, in, out, &fastnat_table, NULL);
+}
+
+static struct nf_hook_ops ipt_ops[]
+= { { { NULL, NULL }, ipt_hook, PF_INET, NF_IP_LOCAL_IN,
+      NF_IP_PRI_FIRST },
+    { { NULL, NULL }, ipt_hook, PF_INET, NF_IP_PRE_ROUTING,
+      NF_IP_PRI_FIRST },
+    { { NULL, NULL }, ipt_local_out_hook, PF_INET, NF_IP_LOCAL_OUT,
+      NF_IP_PRI_LAST },
+    { { NULL, NULL }, ipt_hook, PF_INET, NF_IP_POST_ROUTING,
+      NF_IP_PRI_LAST }
+};
+
+static int __init init(void)
+{
+	int ret;
+
+	/* Register table */
+	ret = ipt_register_table(&fastnat_table);
+	if (ret < 0)
+		return ret;
+
+	/* Register hooks */
+	ret = nf_register_hook(&ipt_ops[0]);
+	if (ret < 0)
+		goto cleanup_table;
+
+	ret = nf_register_hook(&ipt_ops[1]);
+	if (ret < 0)
+		goto cleanup_hook0;
+
+	ret = nf_register_hook(&ipt_ops[2]);
+	if (ret < 0)
+		goto cleanup_hook1;
+
+	ret = nf_register_hook(&ipt_ops[3]);
+	if (ret < 0)
+		goto cleanup_hook2;
+
+	return ret;
+
+ cleanup_hook2:
+	nf_unregister_hook(&ipt_ops[2]);
+ cleanup_hook1:
+	nf_unregister_hook(&ipt_ops[1]);
+ cleanup_hook0:
+	nf_unregister_hook(&ipt_ops[0]);
+ cleanup_table:
+	ipt_unregister_table(&fastnat_table);
+
+	return ret;
+}
+
+static void __exit fini(void)
+{
+	unsigned int i;
+
+	for (i = 0; i < sizeof(ipt_ops)/sizeof(struct nf_hook_ops); i++)
+		nf_unregister_hook(&ipt_ops[i]);
+
+	ipt_unregister_table(&fastnat_table);
+}
+
+module_init(init);
+module_exit(fini);
Index: pplinux/linuxnew/net/ipv4/netfilter/iptable_mangle.c
diff -u pplinux/linuxnew/net/ipv4/netfilter/iptable_mangle.c:1.1.323.1 pplinux/linuxnew/net/ipv4/netfilter/iptable_mangle.c:1.2
--- pplinux/linuxnew/net/ipv4/netfilter/iptable_mangle.c:1.1.323.1	Thu Feb  3 10:00:59 2005
+++ pplinux/linuxnew/net/ipv4/netfilter/iptable_mangle.c	Wed Apr  6 11:53:13 2005
@@ -160,7 +160,9 @@
 	if (ret != NF_DROP && ret != NF_STOLEN && ret != NF_QUEUE
 	    && ((*pskb)->nh.iph->saddr != saddr
 		|| (*pskb)->nh.iph->daddr != daddr
+#ifdef CONFIG_IP_ROUTE_FWMARK
 		|| (*pskb)->nfmark != nfmark
+#endif
 		|| (*pskb)->nh.iph->tos != tos))
 		return ip_route_me_harder(pskb) == 0 ? ret : NF_DROP;
 
Index: pplinux/linuxnew/patches/Makefile
diff -u /dev/null pplinux/linuxnew/patches/Makefile:1.1
--- /dev/null	Tue May 24 10:37:59 2005
+++ pplinux/linuxnew/patches/Makefile	Thu Feb  3 11:35:39 2005
@@ -0,0 +1,38 @@
+# 
+# all target applies patches in the same order as listed in PATCHES
+# clean target removes patches by copying backup in revers order
+#
+PATCHES = \
+	linux-ipmi-2.4.27-v33-base.diff \
+	linux-ipmi-2.4.27-v33-smb.diff
+
+all: patch_done
+
+patch_done:
+	cd ..; c=0;\
+	for p in $(PATCHES); do \
+	   echo "patch -p1 -b -B patches/backup_$$c/ < patches/$$p"; \
+	   patch -p1 -b -B patches/backup_$$c/ < patches/$$p || exit 1; \
+	   let c=$$c+1; \
+        done;
+	touch patch_done
+
+clean:
+	rm -f patch_done
+	if ls -dr backup_*; then \
+	   for d in `ls -dr backup_*`; do \
+	      pushd $$d; \
+	      for i in `find . -type f`; do \
+	         if [ `stat -c %s $$i` = 0 ]; then \
+	            echo rm ../../$$i; \
+	            rm ../../$$i || exit 1; \
+	         else \
+	            echo cp $$i ../../$$i; \
+	            cp $$i ../../$$i || exit 1; \
+	         fi; \
+	      done; \
+	      popd; \
+	      rm -fr $$d; \
+	   done; \
+	fi
+
